import RPi.GPIO as GPIO
from time import sleep
import datetime
import picamera
import threading
import sys

def takingPicture():
    d = datetime.datetime.today()
    filename = "{0}{1:02d}{2:02d}-{3:02d}{4:02d}{5:02d}.jpg".format(d.year, d.month, d.day, d.hour, d.minute, d.second)
    camera.capture(filename)

def my_callback(channel):
    if channel==27:
        t = threading.Thread(target=takingPicture)
        t.start()

camera = picamera.PiCamera()
camera.start_preview()

GPIO.setmode(GPIO.BCM)
GPIO.setup(27, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.add_event_detect(27, GPIO.RISING, callback=my_callback, bouncetime=200)

try:
    while True:
        c = sys.stdin.read(1)
        if c == 'q':
            break

except KeyboardInterrupt:
    pass

camera.stop_preview()
GPIO.cleanup()
