import webiopi
import time
import pigpio

def getServoDutyForWebIOPi(val):
    val_min = 0.0
    val_max = 1.0
    servo_min = 35000   # 最小デューティ比3.5%を10000倍して格納
    servo_max = 100000  # 最大デューティ比10%を10000倍して格納

    duty = int((servo_max-servo_min)*(val-val_min)/(val_max-val_min) + servo_min)
    return duty

pi = pigpio.pi()
pi.set_mode(18, pigpio.OUTPUT)
pi.set_mode(19, pigpio.OUTPUT)
pi.hardware_PWM(18, 50, getServoDutyForWebIOPi(0.5))
pi.hardware_PWM(19, 50, getServoDutyForWebIOPi(0.5))

# デバッグ出力を有効に
webiopi.setDebug()

# WebIOPiの起動時に呼ばれる関数
def setup():
    webiopi.debug("Script with macros - Setup")

# WebIOPiにより繰り返される関数
def loop():
    webiopi.sleep(5)

# WebIOPi終了時に呼ばれる関数
def destroy():
    webiopi.debug("Script with macros - Destroy")
    pi.stop()

# PWMにデューティー比をセットするためのマクロ
# commandIDは、iOSのSafariでPOSTがキャッシュされることへの対策
@webiopi.macro
def setHwPWM(servoID, duty, commandID):
    id = int(servoID)
    duty = getServoDutyForWebIOPi(float(duty))
    if id==0:
        pi.hardware_PWM(18, 50, duty)
    elif id==1:
        pi.hardware_PWM(19, 50, duty)
